/*
 *  Copyright (C) 2009 Daniel Bessler <danielb@kiba-dock.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 *  Author : Daniel Bessler <daniel@orgizm.net>
*/

#ifndef __KIBA_ACTIVITY_H__
#define __KIBA_ACTIVITY_H__

#include <kiba-visual-feature.h>
#include <kiba-win.h>

G_BEGIN_DECLS

typedef struct _KibaActivityFeature KibaActivityFeature;
typedef struct _KibaActivityFeatureClass KibaActivityFeatureClass;

#define KIBA_TYPE_ACTIVITY_FEATURE           (kiba_activity_feature_get_type ())
#define KIBA_ACTIVITY_FEATURE(obj)           (G_TYPE_CHECK_INSTANCE_CAST ((obj), KIBA_TYPE_ACTIVITY_FEATURE, KibaActivityFeature))
#define KIBA_ACTIVITY_FEATURE_CLASS(obj)     (G_TYPE_CHECK_CLASS_CAST ((obj), KIBA_TYPE_ACTIVITY_FEATURE,  KibaActivityFeatureClass))
#define KIBA_IS_ACTIVITY_FEATURE(obj)        (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KIBA_TYPE_ACTIVITY_FEATURE))
#define KIBA_IS_ACTIVITY_FEATURE_CLASS(obj)  (G_TYPE_CHECK_CLASS_TYPE ((obj), KIBA_TYPE_ACTIVITY_FEATURE))
#define KIBA_ACTIVITY_FEATURE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), KIBA_TYPE_ACTIVITY_FEATURE, KibaActivityFeatureClass))

#define ACTIVITY_FEATURE_NAME "activity"
#define ACTIVITY_FEATURE_SIZE 28

struct _KibaActivityFeature {
	KibaVisualFeature parent;
	
	cairo_surface_t *surface;
};

struct _KibaActivityFeatureClass {
	KibaVisualFeatureClass parent_class;
};

KibaVisualFeature* kiba_activity_feature_new(KibaWin *win);

G_END_DECLS

#endif
