/*
 *  Copyright (C) 2009 Daniel Bessler <danielb@kiba-dock.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 *  Author : Daniel Bessler <daniel@orgizm.net>
*/

#ifndef __KIBA_CONTINUOUS_PROGRESS_H__
#define __KIBA_CONTINUOUS_PROGRESS_H__

#include <kiba-visual-feature.h>
#include <kiba-win.h>
#include <kiba-cached-icon.h>

G_BEGIN_DECLS

typedef struct _KibaContinuousProgressFeature KibaContinuousProgressFeature;
typedef struct _KibaContinuousProgressFeatureObject KibaContinuousProgressFeatureObject;
typedef struct _KibaContinuousProgressFeatureClass KibaContinuousProgressFeatureClass;

#define KIBA_TYPE_CONTINUOUS_PROGRESS_FEATURE           (kiba_continuous_progress_feature_get_type ())
#define KIBA_CONTINUOUS_PROGRESS_FEATURE(obj)           (G_TYPE_CHECK_INSTANCE_CAST ((obj), KIBA_TYPE_CONTINUOUS_PROGRESS_FEATURE, KibaContinuousProgressFeature))
#define KIBA_CONTINUOUS_PROGRESS_FEATURE_CLASS(obj)     (G_TYPE_CHECK_CLASS_CAST ((obj), KIBA_TYPE_CONTINUOUS_PROGRESS_FEATURE,  KibaContinuousProgressFeatureClass))
#define KIBA_IS_CONTINUOUS_PROGRESS_FEATURE(obj)        (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KIBA_TYPE_CONTINUOUS_PROGRESS_FEATURE))
#define KIBA_IS_CONTINUOUS_PROGRESS_FEATURE_CLASS(obj)  (G_TYPE_CHECK_CLASS_TYPE ((obj), KIBA_TYPE_CONTINUOUS_PROGRESS_FEATURE))
#define KIBA_CONTINUOUS_PROGRESS_FEATURE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), KIBA_TYPE_CONTINUOUS_PROGRESS_FEATURE, KibaContinuousProgressFeatureClass))

#define CONTINUOUS_PROGRESS_FEATURE_NAME "continuous_progress"

struct _KibaContinuousProgressFeature {
	KibaVisualFeature parent;
	
	float size;
	
	KibaCachedIcon *cached_icon;
};

struct _KibaContinuousProgressFeatureObject {
	KibaContinuousProgressFeature *progress;
	KibaVisualFeatureObject *object;
	gint timeout_id;
	float animate_value;
	float alpha;
	gboolean running;
};

struct _KibaContinuousProgressFeatureClass {
	KibaVisualFeatureClass parent_class;
};

KibaVisualFeature* kiba_continuous_progress_feature_new(KibaWin *win);

G_END_DECLS

#endif
