/*
 *  Copyright (C) 2009 Daniel Bessler <danielb@kiba-dock.org>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 *  Author : Daniel Bessler <daniel@orgizm.net>
*/

#ifndef __KIBA_REFLECTION_H__
#define __KIBA_REFLECTION_H__

#include <kiba-visual-feature.h>
#include <kiba-win.h>

G_BEGIN_DECLS

typedef struct _KibaReflectionFeature KibaReflectionFeature;
typedef struct _KibaReflectionFeatureClass KibaReflectionFeatureClass;

#define KIBA_TYPE_REFLECTION_FEATURE           (kiba_reflection_feature_get_type ())
#define KIBA_REFLECTION_FEATURE(obj)           (G_TYPE_CHECK_INSTANCE_CAST ((obj), KIBA_TYPE_REFLECTION_FEATURE, KibaReflectionFeature))
#define KIBA_REFLECTION_FEATURE_CLASS(obj)     (G_TYPE_CHECK_CLASS_CAST ((obj), KIBA_TYPE_REFLECTION_FEATURE,  KibaReflectionFeatureClass))
#define KIBA_IS_REFLECTION_FEATURE(obj)        (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KIBA_TYPE_REFLECTION_FEATURE))
#define KIBA_IS_REFLECTION_FEATURE_CLASS(obj)  (G_TYPE_CHECK_CLASS_TYPE ((obj), KIBA_TYPE_REFLECTION_FEATURE))
#define KIBA_REFLECTION_FEATURE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), KIBA_TYPE_REFLECTION_FEATURE, KibaReflectionFeatureClass))

#define REFLECTION_FEATURE_NAME "reflection"

struct _KibaReflectionFeature {
	KibaVisualFeature parent;
};

struct _KibaReflectionFeatureClass {
	KibaVisualFeatureClass parent_class;
};

KibaVisualFeature* kiba_reflection_feature_new(KibaWin *win);

G_END_DECLS

#endif
